//+------------------------------------------------------------------+
//|                                                        SmWPR.mq4 |
//|                      Copyright  2006, MetaQuotes Software Corp. |
//|                                        http://www.metaquotes.net |
//+------------------------------------------------------------------+
#property copyright "Copyright  2006, MetaQuotes Software Corp."
#property link      "http://www.metaquotes.net"

#property indicator_chart_window
#property indicator_buffers 2
#property indicator_color1 Gold
#property indicator_color2 Blue
//---- input parameters

extern double    PointX=0;
extern double    PointA=0;
extern double    PointB=0;
extern double    PointC=0;
extern double    PointD=0;
//extern int       BarsCount=200;

//---- buffers
double ExtMapBuffer1[];
double ExtMapBuffer2[];
double ReversalRangeMax=0,ReversalRangeMin=0;
double D_Revers1=0,D_Revers2=0,D_Revers3=0;
int shift=0, Bars_=200;

//+------------------------------------------------------------------+
//| Custom indicator initialization function                         |
//+------------------------------------------------------------------+
int init()
  {
//---- indicators
   /*SetIndexStyle(0,DRAW_LINE);
   SetIndexBuffer(0,ExtMapBuffer1);
   SetIndexStyle(1,DRAW_LINE);
   SetIndexBuffer(1,ExtMapBuffer2);*/
   
   ObjectCreate("ReversalRangeMax_txt",OBJ_TEXT,0,0,Open);
   ObjectCreate("ReversalRangeMin_txt",OBJ_TEXT,0,0,Open);
   ObjectCreate("D_Revers1_txt",OBJ_TEXT,0,0,Open);
   ObjectCreate("D_Revers2_txt",OBJ_TEXT,0,0,Open);
   ObjectCreate("D_Revers3_txt",OBJ_TEXT,0,0,Open);
   ObjectCreate("Target1_txt",OBJ_TEXT,0,0,Open);
   ObjectCreate("Target2_txt",OBJ_TEXT,0,0,Open);
   ObjectCreate("Target3_txt",OBJ_TEXT,0,0,Open);
//----
   return(0);
  }
//+------------------------------------------------------------------+
//| Custor indicator deinitialization function                       |
//+------------------------------------------------------------------+
int deinit()
  {

   ObjectDelete("ReversalRangeMax");
   ObjectDelete("ReversalRangeMin");
   ObjectDelete("D_Revers1");
   ObjectDelete("D_Revers2");
   ObjectDelete("D_Revers3");
   ObjectDelete("Target1");
   ObjectDelete("Target2");
   ObjectDelete("Target3");
   
   ObjectDelete("ReversalRangeMax_txt");
   ObjectDelete("ReversalRangeMin_txt");
   ObjectDelete("D_Revers1_txt");
   ObjectDelete("D_Revers2_txt");
   ObjectDelete("D_Revers3_txt");
   ObjectDelete("Target1_txt");
   ObjectDelete("Target2_txt");
   ObjectDelete("Target3_txt");
   
   Comment("");
   
   return(0);
  }  
//+------------------------------------------------------------------+
//| Custom indicator iteration function                              |
//+------------------------------------------------------------------+

int start()
  {
   double Target1, Target2, Target3;
   /*
   if (BarsCount < 1) {Bars_=Bars;}
   else Bars_=BarsCount;
   
   for(shift=Bars_-1; shift>=0; shift--)
   {
   */   
      ReversalRangeMax=NormalizeDouble(PointA+(PointX-PointA)*0.786,4);
      ReversalRangeMin=NormalizeDouble(PointA+(PointX-PointA)*0.618,4);

      D_Revers1=NormalizeDouble(PointC+(PointB-PointA),4);
      D_Revers2=NormalizeDouble(PointC+(PointB-PointC)*1.618,4);
      D_Revers3=NormalizeDouble(PointC+(PointB-PointC)*1.272,4);
      
      Target1=NormalizeDouble(PointD-(PointD-PointC)*0.618,4);
      Target2=PointD-(PointB-PointC);
      Target3=NormalizeDouble(PointD-(PointD-PointC)*0.786,4);
   //}
      if (ObjectFind("ReversalRangeMax") != 0) 
         {
            ObjectCreate("ReversalRangeMax",OBJ_HLINE,0,Time[25],ReversalRangeMax,Time[1],ReversalRangeMax);
            ObjectSet("ReversalRangeMax",OBJPROP_COLOR,Red);
            ObjectSet("ReversalRangeMax",OBJPROP_WIDTH,1);
            ObjectSet("ReversalRangeMax",OBJPROP_STYLE,STYLE_SOLID);
         }
      else { ObjectMove("ReversalRangeMax", 0,Time[1],ReversalRangeMax); }

      ObjectSetText("ReversalRangeMax_txt", "ReversalRangeMax "+StringSubstr(DoubleToStr(ReversalRangeMax,4),0,6),8,"Arial",White);
      ObjectMove("ReversalRangeMax_txt",0,Time[60],ReversalRangeMax);   
      
      if (ObjectFind("ReversalRangeMin") != 0) 
         {
            ObjectCreate("ReversalRangeMin",OBJ_HLINE,0,Time[25],ReversalRangeMin,Time[1],ReversalRangeMin);
            ObjectSet("ReversalRangeMin",OBJPROP_COLOR,Red);
            ObjectSet("ReversalRangeMin",OBJPROP_WIDTH,1);
            ObjectSet("ReversalRangeMin",OBJPROP_STYLE,STYLE_SOLID);
         }
      else { ObjectMove("ReversalRangeMin", 0,Time[1],ReversalRangeMin); }
      
      ObjectSetText("ReversalRangeMin_txt", "ReversalRangeMin "+StringSubstr(DoubleToStr(ReversalRangeMin,4),0,6),8,"Arial",White);
      ObjectMove("ReversalRangeMin_txt",0,Time[60],ReversalRangeMin);   
         
      if (ObjectFind("D_Revers1") != 0) 
         {
            ObjectCreate("D_Revers1",OBJ_HLINE,0,Time[25],D_Revers1,Time[1],D_Revers1);
            ObjectSet("D_Revers1",OBJPROP_COLOR,Blue);
            ObjectSet("D_Revers1",OBJPROP_WIDTH,1);
            ObjectSet("D_Revers1",OBJPROP_STYLE,STYLE_DOT);
         }
      else { ObjectMove("D_Revers1", 0,Time[1],D_Revers1); }
      
      ObjectSetText("D_Revers1_txt", "D_Revers1 "+StringSubstr(DoubleToStr(D_Revers1,4),0,6),8,"Arial",White);
      ObjectMove("D_Revers1_txt",0,Time[60],D_Revers1);   
      
      if (ObjectFind("D_Revers2") != 0) 
         {
            ObjectCreate("D_Revers2",OBJ_HLINE,0,Time[25],D_Revers2,Time[1],D_Revers2);
            ObjectSet("D_Revers2",OBJPROP_COLOR,LimeGreen);
            ObjectSet("D_Revers2",OBJPROP_WIDTH,1);
            ObjectSet("D_Revers2",OBJPROP_STYLE,STYLE_DOT);
         }
      else { ObjectMove("D_Revers2", 0,Time[1],D_Revers2); }
      
      ObjectSetText("D_Revers2_txt", "D_Revers2 "+StringSubstr(DoubleToStr(D_Revers2,4),0,6),8,"Arial",White);
      ObjectMove("D_Revers2_txt",0,Time[60],D_Revers2);   
      
      if (ObjectFind("D_Revers3") != 0) 
         {
            ObjectCreate("D_Revers3",OBJ_HLINE,0,Time[25],D_Revers3,Time[1],D_Revers3);
            ObjectSet("D_Revers3",OBJPROP_COLOR,Yellow);
            ObjectSet("D_Revers3",OBJPROP_WIDTH,1);
            ObjectSet("D_Revers3",OBJPROP_STYLE,STYLE_DOT);
         }
      else { ObjectMove("D_Revers3", 0,Time[1],D_Revers3); }
      
      ObjectSetText("D_Revers3_txt", "D_Revers3 "+StringSubstr(DoubleToStr(D_Revers3,4),0,6),8,"Arial",White);
      ObjectMove("D_Revers3_txt",0,Time[60],D_Revers3);   
      
      if (ObjectFind("Target1") != 0) 
         {
            ObjectCreate("Target1",OBJ_HLINE,0,Time[25],Target1,Time[1],Target1);
            ObjectSet("Target1",OBJPROP_COLOR,Goldenrod);
            ObjectSet("Target1",OBJPROP_WIDTH,1);
            ObjectSet("Target1",OBJPROP_STYLE,STYLE_DOT);
         }
      else { ObjectMove("Target1", 0,Time[1],Target1); }
      
      ObjectSetText("Target1_txt", "Target1 "+StringSubstr(DoubleToStr(Target1,4),0,6),8,"Arial",White);
      ObjectMove("Target1_txt",0,Time[10],Target1);   
      
      if (ObjectFind("Target2") != 0) 
         {
            ObjectCreate("Target2",OBJ_HLINE,0,Time[25],Target2,Time[1],Target2);
            ObjectSet("Target2",OBJPROP_COLOR,Goldenrod);
            ObjectSet("Target2",OBJPROP_WIDTH,1);
            ObjectSet("Target2",OBJPROP_STYLE,STYLE_DOT);
         }
      else { ObjectMove("Target2", 0,Time[1],Target2); }
      
      ObjectSetText("Target2_txt", "Target2 "+StringSubstr(DoubleToStr(Target2,4),0,6),8,"Arial",White);
      ObjectMove("Target2_txt",0,Time[10],Target2);   

      if (ObjectFind("Target3") != 0) 
         {
            ObjectCreate("Target3",OBJ_HLINE,0,Time[25],Target3,Time[1],Target3);
            ObjectSet("Target3",OBJPROP_COLOR,Goldenrod);
            ObjectSet("Target3",OBJPROP_WIDTH,1);
            ObjectSet("Target3",OBJPROP_STYLE,STYLE_DOT);
         }
      else { ObjectMove("Target3", 0,Time[1],Target3); }
      
      ObjectSetText("Target3_txt", "Target3 "+StringSubstr(DoubleToStr(Target3,4),0,6),8,"Arial",White);
      ObjectMove("Target3_txt",0,Time[10],Target3);   
         
      Comment("Dot B retrace of X-A: ",(PointB-PointA)/(PointX-PointA),"\n",
              "Dot C retrace of X-A: ",(PointC-PointA)/(PointX-PointA),"\n",
              "Dot C retrace of A-B: ",(PointB-PointC)/(PointB-PointA));

      return(0);
  }
//+------------------------------------------------------------------+